package monster;


##############################  f i n d  #######################################
sub find {

($order,$out_power,$format,@traces) = @_;

# x for "anything"
# z for "no digit"

if( $order !~ /\d+/ || $out_power !~ /\d+/ || $#traces != 7) {
  error("Wrong parameters given to find()");
}

# Go!

#@power_maps = pmap($order);

# Open the orders file and get the words

open(DATA, "data/$order.data") or error("find: Could not open $order.data");

@list = ();

while($line = <DATA>) {  # the word

  chomp($line);  
  @input = split(/\|/, $line);  
  
  $found = 1;
  for( $i=3; $i<=10; $i++) {
    if( $traces[$i-3] ne "x") {
      if( $traces[$i-3] eq "z" ) {
        if( $input[$i] =~ /\d+/ ) {
          $found = 0;
          $i=11;
        }
      }
      elsif ( $traces[$i-3] ne $input[$i]) {
        $found = 0;        
        $i=11;        
      }
    }
  }
  if ($found == 1 ) {
    push(@list, $input[0]);
  }
}

if( $format eq "n" ) {
  return( $#list);
}

# sort found elements by length

$end = $#list;      # the last element siftup can touch

if( $end <=1) {
  # do nothing
} else {


$i = int($end/2) +1; # its going to be decremented straight away

$go = 1;

while ($go == 1) {
  if ($i >= 1) {     # heaping
    $i--;
    $inspection = $i;
  }
  else { #sorting
    $end--;
    if ( $end == 0){  # we're done, except elements 1 and 2
      $temp = $list[1];
      $list[1] = $list[0];
      $list[0] = $temp;
      $go = 0;
    }
    else {
      $temp = $list[$end+1];
      $list[$end+1] = $list[0];
      $list[0] = $temp;
      $inspection = 0;
    }
  }
 #either way, siftup is needed
 $goo = 1;
  while ($goo == 1) {
    $first_child = 2*$inspection +1;
    if ($first_child > $end ) {  #no children
      $goo = 0;
    }
    elsif ($first_child == $end ) { #one child
      $f_inspection = length( $list[$inspection] );
      $f_child = length( $list[$first_child] );

      if ( $f_inspect < $f_child) {
        $temp = $list[$inspection];
        $list[$inspection] = $list[$first_child]; 
        $list[$first_child] = $temp; 
        $goo = 0;         #if only 1 child, it has reached the end of the tree
      }
      else {
        $goo = 0;
      }
    }
    else {  # 2 children
      $f_inspection = length( $list[$inspection] );
      $f_first = length( $list[$first_child] );
      $f_second = length( $list[$first_child+1] );

      if( $f_first > $f_second) {
        $greater_child = $first_child;
        $f_greater = $f_first;
      } else {
        $greater_child = $first_child + 1;
        $f_greater = $f_second;
      }

      if ( $f_inspect < $f_greater ) {
        $temp = $list[$inspection];
        $list[$inspection] = $list[$greater_child];
        $list[$greater_child] = $temp;
      }
     $inspection = $greater_child;
    }
  }
}
}  # end " #do nothing "

# get ready for output



if( $format eq "b") {
  if( $list[0] =~ /B+/ ) {
    return(1);
  }
  else {
    return(0);
  }
}
elsif( $format eq "e") {
  if( $list[0] =~ /B+/ ) {
    return($list[0]);
  }
  else {
    return("0");
  }
}
else{
  for($i=0; $i<8; $i++) {
    if( $traces[$i] eq "x") {
      $traces[$i] = " ";
    }
  }

  print "\nElements of order $order with:\n";
  print "Power  mod 2   mod 7\n";
  print "none   $traces[0]       $traces[4]\n";
  print "1st    $traces[1]       $traces[5]\n";
  print "2nd    $traces[2]       $traces[6]\n";
  print "3rd    $traces[3]       $traces[7]\n\n";
  
  foreach $item (@list) {
    print "$item\n";
    print "$out_power\n";
    print "should be $order\n\n";
  }

  print "Done!\n";
}
  

}



####################  p o w e r   m a p  ##########################
sub pmap {
  my $order = $_[0];
  
  open(F, "pmap.data") or error("Coud not open power map file");
  my @power_maps = <F>;
  close(F);
  my $pmp = $power_maps[$order-1];
  my @power_maps = split(/\|/, $pmp);
  return(@power_maps);


}



#####################  e r r o r  #################################
sub error {
  my ($message) = @_;
  print " \n\n * * *  E R R O R !  * * *\n $message\n\n";
  exit;
  
}

#######################################################################

1;
